Subject: Re: bug#55847: 29.0.50; line-number-at-pos ignores absolute parameter when checking position range

From: Antoine Kalmbach <[email-masked]>
Date: Thu, 09 Jun 2022 10:44:25 +0300

Eli Zaretskii <[email-masked]> writes:

>> When working with a narrowed buffer, line-number-at-pos complains
>> that the passed position parameter is out of range.
>> 
>> I believe this occurs because in fns.c there is check as follows:
>> 
>>    if (pos < BEGV || pos > ZV)
>
> Yes, and that's by design.  With very rare exceptions, Emacs always
> behaves as if text outside of the narrowed region doesn't exist.
>
> This is not a bug.
>

Hmm.  The reason I reported a bug is that the pre-28.1 version of
line-number-at-pos, which was in Lisp, did in fact work when the buffer
was narrowed. What is more, the docstring states that:

   If the buffer is narrowed, the return value by default counts the lines
   from the beginning of the accessible portion of the buffer.  But if the
   second optional argument ABSOLUTE is non-nil, the value counts the lines
   from the absolute start of the buffer, disregarding the narrowing.

Hence I would assume that if absolute is non-nil the call to
line-number-at-pos should work even if the buffer is narrowed, instead
of throwing an error.

> You mean BEG, not BEGV_BYTE, I believe.  BEGV_BYTE is the _byte_
> position corresponding to BEGV (which is a character position).

Right, yes. The actual beginning of the buffer, 1.

> Anyway, if you want to get line-number-at-pos outside of the
> restriction, you can simply do
>
>   (save-restriction
>     (widen)
>     (line-number-at-pos POS))
>
> This is what we do in Emacs if we want to access position outside of
> the narrowed region.
>

Yes, thanks, this fixes it, it's what the Lisp version of pre-28 did
this when absolute was non-nil.

-- 
Antoine Kalmbach